<script setup>
import { ref, computed, onMounted } from 'vue';
import { Link, usePage } from '@inertiajs/vue3';
import axios from 'axios';
import { useGeneral } from "@/Composable/General.js";

const { asset } = useGeneral();
const page = usePage();

const user = computed(() => page.props.auth.user);
const cart = ref([]); // Initialize as an empty array

const htmldata = ref('');
const small = () => {
  const html = document.querySelector('html');
  html.dataset.sidebarSize = html.dataset.sidebarSize == "sm" ? "lg" : "sm";
  htmldata.value = html.dataset.sidebarSize;
  console.log(htmldata.value);
};

const fetchCart = async () => {
  try {
    const response = await axios.get(route('api.cart.list'));
    cart.value = response.data.carts;
    console.log(cart.value);
  } catch (error) {
    console.error('Error fetching cart data:', error);
  }
};

const updateCartQuantity = async (itemId, quantity) => {
  try {
    const response = await axios.post(route('api.cart.update'), {
      itemId,
      quantity,
    });
    console.log('Cart item updated successfully:', response.data);
    fetchCart();

  } catch (error) {
    console.error('Error updating cart quantity:', error);
  }
};

const removeItem = async (itemId) => {
  try {
    const url = route('api.cart.delete', { id: itemId });
    await axios.get(url);
    fetchCart();
  } catch (error) {
    console.error('Error removing item from cart:', error);
  }
};

const cartTotal = computed(() => {
  if (Array.isArray(cart.value)) {
    return cart.value.reduce((total, item) => {
      const price = Number(item.menu.price) * Number(item.quantity);
      return total + (isNaN(price) ? 0 : price);
    }, 0);
  }
  return 0;
});

const cartItemCount = computed(() => {
  return cart.value ? cart.value.length : 0;
});

onMounted(() => {
  fetchCart();
});
</script>

<template>
  <header id="page-topbar">
    <div class="layout-width">
      <div class="navbar-header">
        <!-- Button for sidebar toggle -->
        <div class="d-flex">
          <button type="button" class="btn btn-sm px-3 fs-16 header-item vertical-menu-btn topnav-hamburger"
            id="topnav-hamburger-icon" @click="small">
            <span :class="['hamburger-icon', htmldata == 'sm' ? 'open' : '']">
              <span></span>
              <span></span>
              <span></span>
            </span>
          </button>
        </div>
        <div class="d-flex align-items-center">
          <!-- Dropdown for language selection -->
          <div class="dropdown ms-1 topbar-head-dropdown header-item">
            <button type="button" class="btn btn-icon btn-topbar btn-ghost-secondary rounded-circle"
              data-bs-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
              <img id="header-lang-img" :src="asset('assets/images/flags/us.svg')" alt="Header Language" height="20"
                class="rounded" />
            </button>
            <!-- Language dropdown menu -->
          </div>
          <!-- Dropdown for shopping cart -->
          <div class="dropdown topbar-head-dropdown ms-1 header-item">
            <button type="button" class="btn btn-icon btn-topbar btn-ghost-secondary rounded-circle"
              id="page-header-cart-dropdown" data-bs-toggle="dropdown" data-bs-auto-close="outside" aria-haspopup="true"
              aria-expanded="false">
              <i class="bx bx-shopping-bag fs-22"></i>
              <span
                class="position-absolute topbar-badge cartitem-badge fs-10 translate-middle badge rounded-pill bg-info">{{
                  cartItemCount }}</span>
            </button>
            <!-- Shopping cart dropdown menu -->
            <div class="dropdown-menu dropdown-menu-xl dropdown-menu-end p-0 dropdown-menu-cart"
              aria-labelledby="page-header-cart-dropdown">
              <!-- Cart items -->
              <div class="p-3 border-top-0 border-start-0 border-end-0 border-dashed border">
                <div class="row align-items-center">
                  <div class="col">
                    <h6 class="m-0 fs-16 fw-semibold">My Cart</h6>
                  </div>
                  <div class="col-auto">
                    <span class="badge badge-soft-warning fs-13"><span class="cartitem-badge">{{ cartItemCount }}</span>
                      items</span>
                  </div>
                </div>
              </div>
              <!-- Simplebar for cart items -->
              <div data-simplebar style="max-height:500px;">
                <div class="p-2">
                  <div v-if="cart.length <= 0" class="text-center empty-cart" id="empty-cart">
                    <div class="avatar-md mx-auto my-3">
                      <div class="avatar-title bg-soft-info text-info fs-36 rounded-circle">
                        <i class="bx bx-cart"></i>
                      </div>
                    </div>
                    <h5 class="mb-3">Your Cart is Empty!</h5>
                    <Link :href="route('dashboard')" class="btn btn-success w-md mb-3">Shop Now</Link>
                  </div>
                  <div v-else>
                    <table class="table table-bordered">
                      <thead>
                        <tr>
                          <th>Dish Name</th>
                          <th>Price</th>
                          <th>Quantity</th>
                          <th>Total</th>
                          <th>Remove</th>
                        </tr>
                      </thead>
                      <tbody>
                        <tr v-for="item in cart" :key="item.id">
                          <td>
                            <Link :href="route('dashboard')" class="text-reset">{{ item.menu.dish_name }}</Link>
                          </td>
                          <td>
                            RS.<span class="cart-item-price">{{ item.menu.price }}</span>
                          </td>
                          <td>
                            <input type="number" :id="'quantity_' + item.id" class="input-text qty text w-50" step="1"
                              min="1" :value="item.quantity" @change="updateCartQuantity(item.id, $event.target.value)">
                          </td>
                          <td>
                            RS.<span class="cart-item-total">{{ item.quantity * item.menu.price }}</span>
                          </td>
                          <td>
                            <button type="button" class="btn btn-icon btn-sm btn-ghost-secondary remove-item-btn"
                              @click="removeItem(item.id)"><i class="ri-close-fill fs-16"></i></button>
                          </td>
                        </tr>
                      </tbody>
                    </table>
                  </div>
                </div>
              </div>
              <!-- Checkout section -->
              <div class="p-3 border-bottom-0 border-start-0 border-end-0 border-dashed border" id="checkout-elem"
                style="display: block;">
                <div class="d-flex justify-content-between align-items-center pb-3">
                  <h5 class="m-0 text-muted">Total:</h5>
                  <div class="px-2">
                    <h5 class="m-0">RS.<span id="cart-item-total">{{ cartTotal }}</span></h5>
                  </div>
                </div>
                <Link :href="route('order.create')" class="btn btn-success text-center w-100">Checkout</Link>
                <!-- <a href="apps-ecommerce-checkout.html" class="btn btn-success text-center w-100">Checkout</a> -->
              </div>
            </div>
          </div>
          <!-- Dropdown for user profile -->
          <div class="dropdown ms-sm-3 header-item topbar-user">
            <button type="button" class="btn" id="page-header-user-dropdown" data-bs-toggle="dropdown"
              aria-haspopup="true" aria-expanded="false">
              <span class="d-flex align-items-center">
                <img class="rounded-circle header-profile-user" :src="asset('assets/images/users/avatar-1.jpg')"
                  alt="Header Avatar" />
                <span class="text-start ms-xl-2">
                  <span class="d-none d-xl-inline-block ms-1 fw-medium user-name-text">{{ user.name }}</span>
                  <span class="d-none d-xl-block ms-1 fs-12 text-muted user-name-sub-text">
                    {{ user.role == 1 ? "Admin" : (user.role == 2 ? "Restorant" : user.role == 3 ? "Customer" :
                      "Delivery Boy") }}
                  </span>
                </span>
              </span>
            </button>
            <!-- User profile dropdown menu -->
            <div class="dropdown-menu dropdown-menu-end">
              <h6 class="dropdown-header">Welcome {{ user.name }}</h6>
              <Link :href="route('profile.edit')" class="dropdown-item">
              <i class="mdi mdi-account-circle text-muted fs-16 align-middle me-1"></i> Profile
              </Link>
              <Link class="dropdown-item" :href="route('logout')">
              <i class="mdi mdi-logout text-muted fs-16 align-middle me-1"></i> <span class="align-middle"
                data-key="t-logout">Logout</span>
              </Link>
            </div>
          </div>
        </div>
      </div>
    </div>
  </header>
</template>
